new const PLUGIN_VERSION[] = "0.1"

#include <amxmodx>
#include <reapi>

#define rg_get_user_team(%0) get_member(%0, m_iTeam)

new TeamName:g_iTeam[MAX_PLAYERS + 1] = { TEAM_UNASSIGNED, ... }

public plugin_init() {
	register_plugin("Voice Control", PLUGIN_VERSION, "mx?!")

	RegisterHookChain(RG_CBasePlayer_Spawn, "OnPlayerSpawn_Post", true)
	RegisterHookChain(RG_CBasePlayer_Killed, "OnPlayerKilled_Post", true)
	RegisterHookChain(RG_CSGameRules_CanPlayerHearPlayer, "OnCanPlayerHearPlayer_Pre")

	new pCvar = get_cvar_pointer("sv_alltalk")
	set_pcvar_bounds(pCvar, CvarBound_Lower, .set = true, .value = 1.0)
	set_pcvar_bounds(pCvar, CvarBound_Upper, .set = true, .value = 1.0)
}

/* -------------------- */

public OnPlayerSpawn_Post(pPlayer) {
	if(is_user_alive(pPlayer)) {
		g_iTeam[pPlayer] = rg_get_user_team(pPlayer)
	}
}

/* -------------------- */

public OnPlayerKilled_Post(pVictim, pKiller, iGibType) {
	if(!is_user_connected(pVictim)) {
		return
	}

	g_iTeam[pVictim] = TEAM_UNASSIGNED
	client_print_color(pVictim, print_team_red, "^3* ^1Вы мертвы. Всё мёртвые игроки слышат вас, но живые игроки больше не слышат!")
}

/* -------------------- */

public client_disconnected(pPlayer) {
	g_iTeam[pPlayer] = TEAM_UNASSIGNED
}

/* -------------------- */

/*
	1) Живые игроки слышат только других живых членов своей команды
	2) Мёртвые игроки слышат других мёртвых игроков (команда не важна)
	3) Мертвые слышат всех живых игроков
*/
public OnCanPlayerHearPlayer_Pre(pListener, pSender) {
	if(g_iTeam[pListener] != TEAM_UNASSIGNED && g_iTeam[pListener] != g_iTeam[pSender]) {
		SetHookChainReturn(ATYPE_BOOL, false)
		return HC_BREAK // NOTE: will break call in plugins placed below in plugins.ini
	}

	return HC_CONTINUE
}